options(stringsAsFactors = FALSE) 
Sys.setlocale('LC_ALL','C') 
library(tm) 
library(stringi)

setwd("D:/FJRA/NLP/TED_01/DATOS/TED")

text.df<-read.csv('oct_delta.csv')

tweets<- data.frame(ID=seq(1:nrow(text.df)),text=text.df$text)

#Preparacin de datos

#Paso a minsculas

# Return NA instead of tolower error. Esta funcin evita el "pete" del tolower en la librera
#tm. Ms adelante se analiza otra funcin ms potente en otras libreras que no requiere este
#wrapper

tryTolower <- function(x)
{  
  # return NA when there is an error  
  y = NA  
  # tryCatch error  
  try_error = tryCatch(tolower(x), error = function(e) e)  
  # if not an error  
  if (!inherits(try_error, 'error'))    
    
    y = tolower(x)  
  
  return(y) 
  
}

#Eliminacin de stopwords e introduccin de algunas adicionales
custom.stopwords <- c(stopwords('english'), 'lol', 'smh', 'delta')




#LIMPIEZA DE TEXTOS
clean.corpus<-function(corpus)
{  
  corpus <- tm_map(corpus, content_transformer(tryTolower))  
  corpus <- tm_map(corpus, removeWords,  custom.stopwords)  
  corpus <- tm_map(corpus, removePunctuation)  
  corpus <- tm_map(corpus, stripWhitespace)  
  corpus <- tm_map(corpus, removeNumbers)  
  
  return(corpus) 
  
} 

#Corpus de datos con metainformacin de IDs
names(tweets) <-c("doc_id", "text")
corpus <- VCorpus(DataframeSource(tweets))

#Inspeccin de algunos elementos
corpus[[3]][[1]]
corpus[[3]][[2]]

#Limpieza del corpus
corpus<-clean.corpus(corpus) 

corpus[[3]][[1]]
corpus[[3]][[2]]

as.list(corpus)[1]




#ANLISIS DE FRECUENCIAS (y construccin de una matriz trmino-documento)
tdm<-TermDocumentMatrix(corpus,control=list(weighting =weightTf)) 
tdm.tweets.m<-as.matrix(tdm)

dim(tdm.tweets.m)

tdm.tweets.m[2250:2255,1340:1342]

#Construccin de un data frame con 2 columnas, una para los trminos y otra para la
#frecuencia de stos
term.freq<-rowSums(tdm.tweets.m) 
freq.df<-data.frame(word=names(term.freq), frequency=term.freq) 





#Ejercicio: Cules sn los 10 trminos ms y menos frecuentes en los tweets